<?php
include 'securedpage.php';
if($_SERVER['REQUEST_METHOD'] == 'POST')
{
  if($_POST['contacts'] !== NULL)
  {
    $contacts = trim($_POST['contacts']);
    if(!empty($contacts)){
    $contacts = explode(PHP_EOL, $contacts);
    $contacts = array_map('trim', $contacts);
    //var_dump($contacts);exit();
    foreach ($contacts as $key => $value) {
      if(filter_var($value, FILTER_VALIDATE_EMAIL))
      {
      add__new_contact($value);
      }

    }
    $success = "Contacts has been imported.";
  }
  else
  {
    $error = "Import was not successful.";
  }
}
}
?>
<!DOCTYPE html>
<html>
<head>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width, initial-scale=1">
	<title>Mailbot</title>
	<link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-EVSTQN3/azprG1Anm3QDgpJLIm9Nao0Yz1ztcQTwFspd3yD65VohhpuuCOmLASjC" crossorigin="anonymous">
	<link rel="stylesheet" type="text/css" href="assets/style.css">
</head>


<body>
<nav class="navbar navbar-expand-lg navbar-dark bg-dark">
  <div class="container-fluid">
    <a class="navbar-brand" href="#"></a>
    <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarNav" aria-controls="navbarNav" aria-expanded="false" aria-label="Toggle navigation">
      <span class="navbar-toggler-icon"></span>
    </button>
    <div class="collapse navbar-collapse" id="navbarNav">
      <ul class="navbar-nav ms-md-auto gap-2">
        <li class="nav-item rounded">
          <a class="nav-link" aria-current="page" href="home.php"><i class="bi bi-house-fill me-2"></i>Home</a>
        </li>
        <li class="nav-item rounded">
          <a class="nav-link active" href="contacts.php"><i class="bi bi-people-fill me-2"></i>Add Contacts</a>
        </li>
        <li class="nav-item rounded">
          <a class="nav-link" href="integrations.php"><i class="bi bi-telephone-fill me-2"></i>Integration</a>
        </li>
        <li class="nav-item dropdown rounded">
          <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown" role="button" data-bs-toggle="dropdown" aria-expanded="false"><i class="bi bi-person-fill me-2"></i>Profile</a>
          <ul class="dropdown-menu dropdown-menu-end" aria-labelledby="navbarDropdown">

            <li><a class="dropdown-item" href="logout.php">Logout</a></li>
          </ul>
        </li>
      </ul>
    </div>
  </div>
</nav>
<div class="vh-100 row mt-100">
  <div class="col-lg-6 offset-lg-3">
  <h2 class="text-center">Import Bulk Contacts</h2>
  <p class="text-center">Add emails seperated by line.</p>
  <?php 
      if(isset($success))
      {
        ?>
      <div class="alert alert-success"><?=$success;?></div>
      <?php 
    }
    ?>
 <?php 
      if(isset($error))
      {
        ?>
      <div class="alert alert-danger"><?=$error;?></div>
      <?php 
    }
    ?>
  <form method="POST" action="">
    <div class="form-group">
      <textarea class="form-control" name="contacts" placeholder="Import bulk contacts. Seperated by line.&#10;E.g:&#10;example@example.com&#10;example@example.com" style="height: 500px;"></textarea>
    </div>
    <br>
    <button type="submit" class="btn btn-dark">Import Contacts</button>
  </form>
</div>
</div>
<div class="bg-dark text-white">
  <p class="text-center p-4 m-0">Footer Content</p>
</div>
<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.7.1/jquery.min.js" integrity="sha512-v2CJ7UaYy4JwqLDIrZUI/4hqeoQieOmAZNXBeQyjo21dadnwR+8ZaIJVT8EE2iyI61OV8e6M8PP2/4hpQINQ/g==" crossorigin="anonymous" referrerpolicy="no-referrer"></script>

<script src="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/js/bootstrap.bundle.min.js" integrity="sha384-MrcW6ZMFYlzcLA8Nl+NtUVF0sA7MsXsP1UyJoMp4YLEuNSfAP+JcXn/tWtIaxVXM" crossorigin="anonymous"></script>
</body>
</html>