<?php

require_once 'db.php';
$oConnection = new dbConnection();
function mysqli_prepared_query($sql, $paramTypes = '', $params = []) {
   global $oConnection;
  $con = $oConnection->dbc;
   //var_dump($params);exit();
    // Determine the query type based on the first word of the query
    $queryType = strtolower(trim(explode(" ", $sql)[0]));


    $stmt = $con->prepare($sql);

    if ($stmt === FALSE) {
        return false;
    }

    // Bind parameters for prepared statements if provided
    if (!empty($paramTypes) && !empty($params)) {
      $refp = array_merge([$paramTypes], $params);
      $pref = [];

      foreach ($refp as $key => $value) {
        // code...
        $pref[$key] = &$refp[$key];
      }

        call_user_func_array([$stmt, 'bind_param'], $pref);
    }
  
    $result = $stmt->execute();

    if ($result === TRUE) {
        if ($queryType == "select") {
            $resultSet = $stmt->get_result();
            $rows = $resultSet->fetch_all(MYSQLI_ASSOC);
            return $rows;
        } else {       
        
          return true;
            
        }
    } else  {
          return false;

     
    } 


    $stmt->close();
    $con->close();
}

function GetAccountDetails()
{
  $sql = "SELECT * FROM tblmembers WHERE ID = ?";

  $params = array($_SESSION['UserID']);
  $Rows   = mysqli_prepared_query($sql, "i", $params);

  return $Rows[0];
}


function CheckCredentials($UserName, $Password, $Remember)
{
  $UserName = str_replace("'", "", $UserName);
  $UserName = str_replace(";", "", $UserName);
  $Password = str_replace("'", "", $Password);
  $Password = str_replace(";", "", $Password);
  $UserName = trim(strip_tags($UserName));
  $Password = trim(strip_tags($Password));

  $sql = "SELECT ID, Name FROM tblmembers WHERE Username = ? AND Password = ?  ";
  $params = array($UserName, md5($Password));
  $result = mysqli_prepared_query($sql, "ss", $params);



  if ($result[0]['ID'] > 0) {

    if ($Remember == true) {
      setcookie('br_username', $UserName, time() + 60 * 60 * 24 * 365);
      setcookie('br_password', md5($Password), time() + 60 * 60 * 24 * 365);
    } else {
      setcookie('br_username', $UserName, false);
      setcookie('br_password', md5($Password), false);
    }
    $_SESSION['UserID'] = $result[0]['ID'];
    $_SESSION['Name'] = $result[0]['Name'];
    $_SESSION['Username'] = $UserName;
    return 1;
  } else {
    return 0;
  }
}

function CookieCredentials($Username)
{
  $sql = "SELECT Password, ID, Name, Level  FROM tblmembers WHERE Username = ?";
  $params = array($Username);
  $result = mysqli_prepared_query($sql, "s", $params);
  return $result[0];
}

function GetUserID($Email)
{
  $sql = "SELECT ID from tblmembers WHERE Username = ?";
  $params = array($Email);
  $result = mysqli_prepared_query($sql, "s", $params);
  return $result[0]['ID'];
}

function get_getresponse_lists($api)
{
$curl = curl_init();

curl_setopt_array($curl, array(
  CURLOPT_URL => 'https://api.getresponse.com/v3/campaigns',
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => '',
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 0,
  CURLOPT_FOLLOWLOCATION => true,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => 'GET',
  CURLOPT_HTTPHEADER => array(
    'Content-Type: application/json',
    'X-Auth-Token: api-key '.$api['api']
  ),
));

$response = curl_exec($curl);

curl_close($curl);
return $response;

}


function add_getresponse_contact($email)
{

$grde = get_option('getresponse');
$grde = json_decode($grde);
$curl = curl_init();

curl_setopt_array($curl, array(
  CURLOPT_URL => 'https://api.getresponse.com/v3/contacts',
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => '',
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 0,
  CURLOPT_FOLLOWLOCATION => true,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => 'POST',
  CURLOPT_POSTFIELDS =>'{
  "campaign": {
    "campaignId": "'.$grde->list.'"
  },
  "email": "'.$email.'"
}',
  CURLOPT_HTTPHEADER => array(
    'Content-Type: application/json',
    'X-Auth-Token: api-key '.$grde->api
  ),
));

$response = curl_exec($curl);
$httpCode = curl_getinfo($curl, CURLINFO_HTTP_CODE);
curl_close($curl);
//var_dump($response);exit;
if($httpCode == 202)
{
    return true;
}
else
{
    return false;
}

}

function create_sendx_contact($email)
{
  require_once 'integrations/sendx-api-php/autoload.php';
  $api_instance = new Swagger\Client\Api\ContactApi();
  $api_key = "KaKmmwQmxdVhiujsK0TM"; // string | 
  $team_id = "syV3Ra5ORSIHz4D1IYgONU"; // string | 
  $contact_details = new \Swagger\Client\Model\ContactRequest(); // \Swagger\Client\Model\ContactRequest | Contact details
  $contact_details->setEmail($email);
  try {
      $result = $api_instance->contactIdentifyPost($api_key, $team_id, $contact_details);
      print_r($result);
  } catch (Exception $e) {
      echo 'Exception when calling ContactApi->contactIdentifyPost: ', $e->getMessage(), PHP_EOL;
  }
}

function create_sendlane_contact($contact)
{
 
  $apis = get_option('sandlane');
  $apis = json_decode($apis);
  $token = $apis->token;
  $list = $apis->list;


$curl = curl_init();

curl_setopt_array($curl, [
  CURLOPT_URL => "https://api.sendlane.com/v2/lists/".$list."/contacts",
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => "",
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 30,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => "POST",
  CURLOPT_POSTFIELDS => json_encode([
    'contacts' => [
        [
                'email' => $contact,
                'email_consent' => true
        ]
    ]
  ]),
  CURLOPT_HTTPHEADER => [
    "Authorization: Bearer ".$token,
    "Content-Type: application/json"
  ],
]);

$response = curl_exec($curl);

$httpCode = curl_getinfo($curl, CURLINFO_HTTP_CODE);
curl_close($curl);
$response = json_decode($response);

if($httpCode == 202 || $httpCode == 200 || $httpCode == 201 || $response->message == 'Email or list is suppressed')
{
  return true;
}
else
{
  return false;
}
}

function add_option($name, $value)
{
  if(check_option_not_exist($name))
  {
    $sql = "INSERT INTO options (name, value) VALUES (?, ?)";
    $param = array($name, $value);
    if(mysqli_prepared_query($sql, 'ss', $param))
    {
      return true;
    }
    else
    {
      return false;
    }
  }
  else
  {
    $sql = "UPDATE options SET value = ? WHERE name = ?";
    $param = array($value, $name);
    if(mysqli_prepared_query($sql, 'ss', $param)){
      return true;
    }
    else
    {
      return false;
    }
  }
}

function check_option_not_exist($name)
{
  $sql = "SELECT id FROM options WHERE name = ?";
  $param = array($name);
  $row = mysqli_prepared_query($sql, 's', $param);
  if(empty($row))
  {
    return true;
  }
  else
  {
    return false;
  }
}
function get_option($name)
{
  $sql = "SELECT value FROM options WHERE name = ?";
  $param = array($name);
  $row = mysqli_prepared_query($sql, 's', $param);
  return $row[0]['value'];
}

function add__new_contact($email)
{
  if(!check_email_exist($email))
  {
    $sql = "INSERT INTO emails (email) VALUES (?)";
    $params = array($email);
    mysqli_prepared_query($sql, 's', $params);
  }
}
function check_email_exist($email)
{
  $sql = "SELECT id FROM emails WHERE email = ?";
  $params = array($email);
  $row = mysqli_prepared_query($sql, 's', $params);
  return !empty($row);
}

function get_one_email()
{
  $sql = "SELECT * FROM emails WHERE processed = ? ORDER BY id ASC LIMIT 0,1";
  $param = array(0);
  $row = mysqli_prepared_query($sql, 'i', $param);
  return $row[0];
}

function update_sendlane_contact($email)
{
  $sql = "UPDATE emails SET processed = ? WHERE email = ?";
  $params = array(1, $email);
  mysqli_prepared_query($sql, 'is', $params);
}

function fetch_sendlane_lists($data)
{
 $api = $data['api'];

$curl = curl_init();

curl_setopt_array($curl, [
  CURLOPT_URL => "https://api.sendlane.com/v2/lists",
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => "",
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 30,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => "GET",
  CURLOPT_HTTPHEADER => [
    "Authorization: Bearer ".$api,
    "Content-Type: application/json"
  ],
]);

$response = curl_exec($curl);
$httpCode = curl_getinfo($curl, CURLINFO_HTTP_CODE);
curl_close($curl);
if($httpCode == 200)
{
return $response;

}
else
{
return array('error' => 1);
}
}

function count_total_emails()
{
  $sql = "SELECT COUNT(*) AS total FROM emails";
  $row = mysqli_prepared_query($sql);
  return $row[0]['total'];
}

function count_total_dripped_emails()
{
  $sql = "SELECT COUNT(*) AS total FROM emails WHERE processed = 1";
  $row = mysqli_prepared_query($sql);
  return $row[0]['total'];
}
function count_total_dripped_ready_emails()
{
  $sql = "SELECT COUNT(*) AS total FROM emails WHERE processed = 0";
  $row = mysqli_prepared_query($sql);
  return $row[0]['total'];
}

function refresh_aweber_token()
{
$aweberd = get_option('aweber');
$aweberd = json_decode($aweberd);
$clientId = 'JonADd2b93m6vX5EtDQOtWHGwJMKn98z';
$clientSecret = 'lXnWEXFm9FrITyIW8zc8TvafyWrcfajS';
$refreshToken = $aweberd->refresh_token;

$tokenUrl = 'https://auth.aweber.com/oauth2/token';
$postData = [
    'grant_type' => 'refresh_token',
    'client_id' => $clientId,
    'client_secret' => $clientSecret,
    'refresh_token' => $refreshToken
];

$ch = curl_init($tokenUrl);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
curl_setopt($ch, CURLOPT_POST, true);
curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($postData));
$response = curl_exec($ch);
curl_close($ch);

$responseData = json_decode($response, true);
if(isset($responseData['access_token']))
{
    if(isset($aweberd->awlist))
    {
        $postData = array('token' => $responseData['access_token'], 'refresh_token' => $responseData['refresh_token'], 'expires_at' => $responseData['expires_in'], 'awlist' => $aweberd->awlist, 'accountId'=> $aweberd->accountId);
    }
    else
    {
    $postData = $postData = array('token' => $responseData['access_token'], 'refresh_token' => $responseData['refresh_token'], 'expires_at' => $responseData['expires_in'], 'awlist' => '', 'accountId'=> $aweberd->accountId);
    }
    add_option('aweber', json_encode($postData));
}
}

function get_aweber_lists()
{
    $aweberd = get_option('aweber');
    $aweberd = json_decode($aweberd);
    $accountId = $aweberd->accountId;
    $accessToken = $aweberd->token;
    $listsUrl = 'https://api.aweber.com/1.0/accounts/' . $accountId . '/lists';
//echo $listsUrl; exit;
    $ch = curl_init($listsUrl);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_HTTPHEADER, ['Authorization: Bearer ' . $accessToken]);
    $listsResponse = curl_exec($ch);
    curl_close($ch);
    $listsResponse = json_decode($listsResponse);
    return $listsResponse->entries;
}

function get_aweber_account_id($accessToken)
{

$apiUrl = 'https://api.aweber.com/1.0/accounts';
$ch = curl_init($apiUrl);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
curl_setopt($ch, CURLOPT_HTTPHEADER, ['Authorization: Bearer ' . $accessToken]);
$response = curl_exec($ch);
curl_close($ch);

$accounts = json_decode($response, true);
//print_r($accounts);
return $accounts['entries'][0]['id'];
}

function add_new_aweber_subscriber($email)
{

$awde = get_option('aweber');
$awde = json_decode($awde);

// AWeber API endpoint for adding subscribers to a list
$listId = $awde->awlist;
$accessToken = $awde->token;
$accountId = $awde->accountId;
$apiUrl = 'https://api.aweber.com/1.0/accounts/'.$accountId.'/lists/' . $listId . '/subscribers';
// Subscriber data
$data = [
    'email' => $email
];

$ch = curl_init($apiUrl);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
curl_setopt($ch, CURLOPT_POST, true);
curl_setopt($ch, CURLOPT_HTTPHEADER, ['Authorization: Bearer ' . $accessToken, 'Content-Type: application/json']);
curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($data));
$response = curl_exec($ch);
$httpCode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
curl_close($ch);

$res = json_decode($response);
if(isset($res->error->message))
{
    $res = $res;
}
else
{
    $res = '';
}

if($httpCode == 201 || $res->error->message == 'email: Subscriber already subscribed.' || empty($res))
{
    return true;
}
else
{
    return false;
}
}
?>